{% set industryClassificationShortNames = {
    1: 'E',
    2: 'D',
    3: 'G',
    4: 'KK',
    5: 'PA',
    6: 'BL',
    7: 'GW',
    8: 'SW',
    9: 'V',
    10: 'IV',
    11: 'PG',
    12: 'KW',
    13: 'GH',
    14: 'AG',
    15: 'W',
    16: 'NG',
} %}

<div class="mdc-card object-card-component h-100" data-building-unit-id="{{ buildingUnit.getId() }}">
    {% if buildingUnit.getMainImage() is not null %}
        {% if buildingUnit.getMainImage().getThumbnailFile is not null %}
            {% set image = path('file', {'fileUuid': buildingUnit.getMainImage().getThumbnailFile().getUuid()}) %}
        {% else %}
            {% set image = path('file', {'fileUuid': buildingUnit.getMainImage().getFile().getUuid()}) %}
        {% endif %}
    {% else %}
        {% set image = asset('build/images/no-image.jpg') %}
    {% endif %}
    <div class="lazy-image-loader my-card__media mdc-card__media mdc-card__media--16-9" data-background-image="{{ image }}"></div>
    {% if buildingUnit.isObjectIsEmpty() %}
        <span class="position-absolute top-0 start-100 translate-middle p-2 bg-danger border border-light rounded-circle">
            <span class="visually-hidden">Objekt steht leer</span>
        </span>
    {% endif %}
    {% if buildingUnit.isObjectBecomesEmpty() %}
        <span class="position-absolute top-0 start-100 translate-middle p-2 bg-warning border border-light rounded-circle">
            <span class="visually-hidden">Objekt fällt leer</span>
        </span>
    {% endif %}

    <div class="d-flex flex-column p-2 h-100">
        <div class="d-flex mb-1 justify-content-between">
            <div class="d-flex flex-column">
                <strong>{{ buildingUnit.getName() }}</strong><br>
                <small class="mb-1">Objekt-Nr.: {{ buildingUnit.getId() }}{% if buildingUnit.getInternalNumber() %} ({{ buildingUnit.getInternalNumber() }}){% endif %}</small>
            </div>
            {% if is_granted('view', buildingUnit) == true %}
                {% include 'component/mdc_context_menu_component.html.twig' with {
                    'id': 'building_unit_' ~ buildingUnit.getId(),
                    'listItems': [
                        {
                            'label': 'zum Objekt',
                            'url': path('property_vacancy_management_building_unit_basic_data', {'buildingUnitId': buildingUnit.getId()}),
                            'icon': 'store'
                        },
                    ]
                } only %}
            {% endif %}
        </div>
        <div class="d-flex flex-row mb-1">
            <div class="p-1">
                <span class="material-icons-outlined">
                    pin_drop
                </span>
            </div>
            <div class="p-1">
                <span>{{ buildingUnit.getAddress().getStreetName() }} {{ buildingUnit.getAddress().getHouseNumber() }}</span><br>
                <span>{{ buildingUnit.getAddress().getPostalCode() }} {{ buildingUnit.getAddress().getPlace().getPlaceName() }}</span>
            </div>
        </div>
        {% if (buildingUnit.isObjectIsEmpty() and buildingUnit.getObjectIsEmptySince() != null) or (buildingUnit.isObjectBecomesEmpty() and buildingUnit.getObjectBecomesEmptyFrom() != null) %}
            <div class="d-flex flex-row docs-highlight mb-1">
                <div class="p-1 docs-highlight">
                    <span class="material-icons-outlined {% if buildingUnit.isObjectIsEmpty() %}text-danger{% endif %} {% if buildingUnit.isObjectBecomesEmpty() %}text-warning{% endif %}">
                        {% if buildingUnit.isObjectIsEmpty() %}error{% endif %} {% if buildingUnit.isObjectBecomesEmpty() %}gpp_maybe{% endif %}
                    </span>
                </div>
                <div class="p-1 docs-highlight">
                    {% if buildingUnit.isObjectIsEmpty() %}
                        Leerstand seit: {{ buildingUnit.getObjectIsEmptySince().format('d.m.Y') }}
                    {% else %}
                        Fällt leer zum: {{ buildingUnit.getObjectBecomesEmptyFrom().format('d.m.Y') }}
                    {% endif %}
                </div>
            </div>
        {% endif %}
        {% if buildingUnit.getPropertyMarketingInformation().getPossibleUsageIndustryClassifications() is defined and buildingUnit.getPropertyMarketingInformation().getPossibleUsageIndustryClassifications()|length > 0 %}
            <div class="d-flex flex-row mb-1">
                <div class="p-1">
                <span class="material-icons-outlined">
                    location_city
                </span>
                </div>
                <div class="p-1">
                    <div class="mdc-tooltip-wrapper--rich">
                        {{ buildingUnit.getPropertyMarketingInformation().getPossibleUsageIndustryClassifications()|map((value, key) => industryClassificationShortNames["#{value}".getLevelOne()])|join(', ') }}
                        <span class="material-icons-outlined mdc-tooltip-anchor" aria-describedby="building-unit-{{ buildingUnit.getId() }}-possible-property-usage-mdc-tooltip">info</span>
                        <div id="building-unit-{{ buildingUnit.getId() }}-possible-property-usage-mdc-tooltip" class="mdc-tooltip mdc-tooltip--rich" role="tooltip" aria-hidden="true">
                            <div class="mdc-tooltip__surface mdc-tooltip__surface-animation">
                                <div class="mdc-tooltip__content">
                                    <strong>Mögliche Nutzung</strong>
                                    <ul>
                                        {% for possibleIndustryClassification in buildingUnit.getPropertyMarketingInformation().getPossibleUsageIndustryClassifications() %}
                                            <li>{{ possibleIndustryClassification.getName() }}</li>
                                        {% endfor %}
                                    </ul>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        {% endif %}
    </div>
    <hr>
    <div class="d-flex flex-column">
        {% set matchingTask = buildingUnit.getMatchingTask() %}
        {% set settlementConceptMatchingTask = buildingUnit.getSettlementConceptMatchingTask() %}

        {% if matchingTask != null and settlementConceptMatchingTask != null %}
            {% if
                (matchingTask != null and (matchingTask.getTaskStatus().name == 'CREATED' or matchingTask.getTaskStatus().name == 'IN_PROGRESS'))
                or (
                    settlementConceptMatchingTask != null
                    and (settlementConceptMatchingTask.getTaskStatus().name == 'CREATED' or settlementConceptMatchingTask.getTaskStatus().name == 'IN_PROGRESS')
                )
            %}
                <div class="last-matching-date-label px-2 pb-0">
                    <div class="mb-3 text-warning">
                        <div class="spinner-border spinner-border-sm text-warning me-1" role="status">
                            <span class="visually-hidden">Loading...</span>
                        </div>
                        <strong>Matching wird derzeit ausgeführt</strong>
                    </div>
                    <p class="mb-3">Bitte laden Sie die Seite in den nächsten Minuten neu, um die Ergebnisse aufzurufen.</p>
                </div>
            {% elseif (matchingTask != null and matchingTask.getTaskStatus().name == 'FAILED') or (settlementConceptMatchingTask != null and settlementConceptMatchingTask.getTaskStatus().name == 'FAILED') %}
                <p class="last-matching-date-label px-2 text-danger"><strong>Noch kein Matching ausgeführt</strong></p>
                {% if is_granted('ROLE_USER') == true %}
                    <div class="mdc-card__actions align-self-center w-100 mb-1">
                        <a href="{{ path('company_location_management_matching_object_matching_task_create', {'id': buildingUnit.getId()}) }}" class="mdc-button mdc-button--raised mdc-button--leading ms-auto align-self-center w-100">
                            <i class="material-icons me-3">cached</i>
                            <span class="mdc-button__label">Matching starten</span>
                        </a>
                    </div>
                {% endif %}
            {% elseif (matchingTask != null and matchingTask.getTaskStatus().name == 'DONE') or (settlementConceptMatchingTask != null and settlementConceptMatchingTask.getTaskStatus().name == 'DONE') %}
                {% if matchingTask != null %}
                    {% set updatedAt = matchingTask.getUpdatedAt() %}
                {% else %}
                    {% set updatedAt = settlementConceptMatchingTask.getUpdatedAt() %}
                {% endif %}

                {% if buildingUnit.getMatchingResults() is empty and buildingUnit.getSettlementConceptMatchingResults() is empty %}
                    {% if buildingUnit.getPropertyMarketingInformation().getPropertyOfferType() == null or buildingUnit.getAreaSize() == null or buildingUnit.getPropertyMarketingInformation().getPossibleUsageIndustryClassifications() is empty %}
                        <div class="mdc-tooltip-wrapper--rich">
                            <div class="last-matching-date-label px-2">
                                Keine Treffer am: {{ updatedAt.format('d.m.Y, H:i') }}
                                <span class="material-icons-outlined text-warning align-bottom mdc-tooltip-anchor" aria-describedby="building-unit-{{ buildingUnit.getId() }}-missing-matching-relevant-fields-mdc-tooltip">
                                    report
                                </span>
                                <div id="building-unit-{{ buildingUnit.getId() }}-missing-matching-relevant-fields-mdc-tooltip" class="mdc-tooltip mdc-tooltip--rich" role="tooltip" aria-hidden="true">
                                    <div class="mdc-tooltip__surface mdc-tooltip__surface-animation">
                                        <div class="mdc-tooltip__content">
                                            <p><strong>Das Matching liefert vermutlich keine Ergebnisse:</strong></p>
                                            <p>Es sind einige wichtige Matching-relevante Felder des Objekts nicht gefüllt. Bitte kontrollieren Sie insbesondere folgende Felder</p>
                                            <ul>
                                                {% if buildingUnit.getPropertyMarketingInformation().getPropertyOfferType() == null %}
                                                    <li>Angebotsart (Kauf, Miete, Pacht)</li>
                                                {% endif %}
                                                {% if buildingUnit.getAreaSize() == null %}
                                                    <li>Gesamtgröße</li>
                                                {% endif %}
                                                {% if buildingUnit.getPropertyMarketingInformation().getPossibleUsageIndustryClassifications() is empty %}
                                                    <li>Mögliche Nutzung</li>
                                                {% endif %}
                                            </ul>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    {% else %}
                        <p class="last-matching-date-label px-2">
                            Keine Treffer am: {{ updatedAt.format('d.m.Y, H:i') }}
                        </p>
                    {% endif %}
                {% else %}
                    <p class="last-matching-date-label px-2">Letztes Matching am: {{ updatedAt.format('d.m.Y, H:i') }} Uhr</p>
                {% endif %}
                <div class="d-flex flex-row mdc-card__actions align-self-center w-100 mb-1">
                    {% if buildingUnit.getMatchingResults()|length > 0 or buildingUnit.getSettlementConceptMatchingResults()|length > 0 %}
                        <a href="{{ path('company_location_management_matching_object_detail', {'id': buildingUnit.getId()}) }}" class="mdc-button mdc-button--raised mdc-button--leading ms-auto align-self-center w-100">
                            <i class="material-icons me-3">launch</i>
                            <span class="mdc-button__label">{{ (buildingUnit.getMatchingResults()|length + buildingUnit.getSettlementConceptMatchingResults()|length) }} Treffer</span>
                        </a>
                        {% if is_granted('ROLE_USER') == true %}
                            <a href="{{ path('company_location_management_matching_object_matching_task_create', {'id': buildingUnit.getId()}) }}" class="material-icons mdc-icon-button mdc-card__action mdc-card__action--icon text-secondary ms-1" title="Matching erneut ausführen">
                                <div class="mdc-icon-button__ripple"></div>
                                cached
                            </a>
                        {% endif %}
                    {% else %}
                        {% if is_granted('ROLE_USER') == true %}
                            <a href="{{ path('company_location_management_matching_object_matching_task_create', {'id': buildingUnit.getId()}) }}" class="mdc-button mdc-button--raised mdc-button--leading ms-auto align-self-center w-100">
                                <i class="material-icons me-3">cached</i>
                                <span class="mdc-button__label">Matching starten</span>
                            </a>
                        {% endif %}
                    {% endif %}
                </div>
            {% endif %}
        {% else %}
            {% if buildingUnit.getPropertyMarketingInformation().getPropertyOfferType() == null or buildingUnit.getAreaSize() == null or buildingUnit.getPropertyMarketingInformation().getPossibleUsageIndustryClassifications() is empty %}
                <div class="mdc-tooltip-wrapper--rich">
                    <p class="last-matching-date-label px-2 text-danger">
                        <strong>Noch kein Matching ausgeführt</strong>
                        <span class="material-icons-outlined text-warning align-bottom mdc-tooltip-anchor" aria-describedby="building-unit-{{ buildingUnit.getId() }}-missing-matching-relevant-fields-mdc-tooltip">
                            report
                        </span>
                        <div id="building-unit-{{ buildingUnit.getId() }}-missing-matching-relevant-fields-mdc-tooltip" class="mdc-tooltip mdc-tooltip--rich" role="tooltip" aria-hidden="true">
                            <div class="mdc-tooltip__surface mdc-tooltip__surface-animation">
                                <div class="mdc-tooltip__content">
                                    <p><strong>Das Matching liefert vermutlich keine Ergebnisse:</strong></p>
                                    <p>Es sind einige wichtige Matching-relevante Felder des Objekts nicht gefüllt. Bitte kontrollieren Sie insbesondere folgende Felder</p>
                                    <ul>
                                        {% if buildingUnit.getPropertyMarketingInformation().getPropertyOfferType() == null %}
                                            <li>Angebotsart (Kauf, Miete, Pacht)</li>
                                        {% endif %}
                                        {% if buildingUnit.getAreaSize() == null %}
                                            <li>Gesamtgröße</li>
                                        {% endif %}
                                        {% if buildingUnit.getPropertyMarketingInformation().getPossibleUsageIndustryClassifications() is empty %}
                                            <li>Mögliche Nutzung</li>
                                        {% endif %}
                                    </ul>
                                </div>
                            </div>
                        </div>
                    </p>
                </div>
            {% else %}
                <p class="last-matching-date-label px-2 text-danger"><strong>Noch kein Matching ausgeführt</strong></p>
            {% endif %}
            {% if is_granted('ROLE_USER') == true %}
                <div class="mdc-card__actions align-self-center w-100 mb-1">
                    <a href="{{ path('company_location_management_matching_object_matching_task_create', {'id': buildingUnit.getId()}) }}" class="mdc-button mdc-button--raised mdc-button--leading ms-auto align-self-center w-100">
                        <i class="material-icons me-3">cached</i>
                        <span class="mdc-button__label">Matching starten</span>
                    </a>
                </div>
            {% endif %}
        {% endif %}
    </div>
</div>
